"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var EscDirective = /** @class */ (function () {
    function EscDirective() {
        this.watchEsc = true;
        this.stopEscPropagation = true;
        this.escEvent$ = new core_1.EventEmitter();
    }
    EscDirective.prototype.onKeyDown = function ($event) {
        if (!this.watchEsc) {
            return;
        }
        if (this.stopEscPropagation) {
            $event.stopPropagation();
        }
        this.escEvent$.emit($event);
    };
    EscDirective.decorators = [
        { type: core_1.Injectable },
        { type: core_1.Directive, args: [{ selector: '[esc]' },] },
    ];
    /** @nocollapse */
    EscDirective.ctorParameters = function () { return []; };
    EscDirective.propDecorators = {
        'watchEsc': [{ type: core_1.Input },],
        'stopEscPropagation': [{ type: core_1.Input },],
        'escEvent$': [{ type: core_1.Output, args: ['esc',] },],
        'onKeyDown': [{ type: core_1.HostListener, args: ['document:keydown.escape', ['$event'],] },],
    };
    return EscDirective;
}());
exports.EscDirective = EscDirective;
